ZOJ 3380 Patchouli's Spell Cards(概率DP)

2023-12-17 16:10

本文主要是介绍ZOJ 3380 Patchouli's Spell Cards(概率DP),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

传送门


Patchouli Knowledge, the unmoving great library, is a magician who has settled down in the Scarlet Devil Mansion (紅魔館). Her specialty is elemental magic employing the seven elements fire, water, wood, metal, earth, sun, and moon. So she can cast different spell cards like Water Sign “Princess Undine”, Moon Sign “Silent Selene” and Sun Sign “Royal Flare”. In addition, she can combine the elements as well. So she can also cast high-level spell cards like Metal & Water Sign “Mercury Poison” and Fire, Water, Wood, Metal & Earth Sign “Philosopher’s Stones” .

Assume that there are m different elements in total, each element has n different phase. Patchouli can use many different elements in a single spell card, as long as these elements have the same phases. The level of a spell card is determined by the number of different elements used in it. When Patchouli is going to have a fight, she will choose m different elements, each of which will have a random phase with the same probability. What’s the probability that she can cast a spell card of which the level is no less than l, namely a spell card using at least l different elements.

Input

There are multiple cases. Each case contains three integers 1 ≤ m, n, l ≤ 100. Process to the end of file.

Output

For each case, output the probability as irreducible fraction. If it is impossible, output “mukyu~” instead.

Sample Input
7 6 5
7 7 7
7 8 9
Sample Output
187/15552
1/117649
mukyu~

题目大意:

题目的原意是比较难理解的,将题目抽象一下:有 m 个格子,每个格子可以用 n 种颜色进行涂色,求在这 m 个格子中颜色相同的格子数目  L 的概率。

解题思路:
考虑 DP ,设 dp[i][j] i  j  (是在 m 个格子中涂 j 个,并不是前 j 个),那么有:

dp[i][j]=k=0kjk<ldp[i1][jk]C[m(jk)][k]

解释:因为第 i 种颜色可以不涂,可以涂一个格子,可以涂两个格子,以此类推。
初始化: dp[0][0]=1
因为结果太大,所以考虑 java 大数

import java.math.BigInteger;
import java.util.Scanner;public class Main {static BigInteger C[][] = new BigInteger[105][105];public static void Init(){for(int i=0; i<105; i++) for(int j=0; j<105; j++) C[i][j] = BigInteger.ZERO;for(int i=0; i<105; i++) C[i][0] = BigInteger.ONE;for(int i=1; i<105; i++) for(int j=1; j<105; j++) C[i][j]=C[i][j].add(C[i-1][j].add(C[i-1][j-1]));}public static void main(String[] args) {Init();Scanner in = new Scanner(System.in);    while(in.hasNext()){int m, n, l;m = in.nextInt(); n = in.nextInt(); l = in.nextInt();if(l > m){System.out.println("mukyu~");continue;}BigInteger dp[][] = new BigInteger[105][105];for(int i=0; i<105; i++) for(int j=0; j<105; j++) dp[i][j] = BigInteger.ZERO;dp[0][0] = BigInteger.ONE;for(int i=1; i<=n; i++){for(int j=1; j<=m; j++){for(int k=0; k<=j&&k<l; k++){dp[i][j] = dp[i][j].add(dp[i-1][j-k].multiply(C[m-(j-k)][k]));}}}BigInteger ans = BigInteger.valueOf(n).pow(m);BigInteger tmp = BigInteger.ZERO;for(int i=1; i<=n; i++) tmp = tmp.add(dp[i][m]);tmp = ans.subtract(tmp);BigInteger gcd = tmp.gcd(ans);System.out.println(tmp.divide(gcd)+"/"+ans.divide(gcd));}}
}

这篇关于ZOJ 3380 Patchouli's Spell Cards(概率DP)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/504989

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o